# FXCoreMacTools

Support files for use with Sublime Text 3/4 and Experimental Noize FXCore Assembler on Mac platforms

Requirements:

FXCore Assembler for Mac:  http://www.experimentalnoize.com/product_FXCore.php

.NET Framework for Mac:

https://dotnet.microsoft.com/en-us/download/dotnet/thank-you/runtime-6.0.2-macos-x64-installer  Intel version

https://dotnet.microsoft.com/en-us/download/dotnet/thank-you/runtime-6.0.2-macos-arm64-installer  M1 version

Sublime Text 4:

https://www.sublimetext.com/download

Instructions:

Download all requirements

Install Sublime Text and .NET Framework

Place the FXCore assembler ZIP file in your home directory (Finder -> Go -> Home)

Double click the ZIP file to expand it, this will create a directory called FXCoreAsmMac_Intel or FXCoreAsmMac_M1 depending
on the file you downloaded. Change the name of this directory to FXCoreAsmMac

Run Sublime Text and then exit, this will set up some user directories we need

Navigate to your Sublime Text support folder (Finder -> Go -> Go to Folder -> ~/Library/Application Support/Sublime Text)
Open the Packages folder, then open the User folder.

Copy the three files fxcore_Comments.tmPreferences, fxcore_hw.sublime-build and fxcore.sublime-syntax to the User folder

Open fxcore_sw.sublime-build in a text editor of your choice, including Sublime Text.

Edit line 9 to point to the location where you installed FXCoreAsmMac.  Please note that Sublime Text can't use the "~" shortcut for your user folder name, so this should look something like: 

"working_dir" : "/Users/myusername/FXCoreAsmMac/"

If you're not sure, you can drag the FXCoreAsmMac executable into a Temrinal window to see the path.  ST needs to have the path enclosed by " " quotes and does not need the slashes escaped.

The path in the previous step should NOT include the path to the executable, but only to its containing folder.

Open a .FXC file in Sublime Text, you should see the syntax highlighting keywords / commands / data.

Press Cmd-B or Tools -> Build to build using the assembler, this will assemble the file by default.  Any error messages generated will be shown in the build results pane at the bottom of the Sublime Text window.  You can also press F4 to navigate to errors within the code.

Press Cmd-Shift-B or Tools -> Build With... to access alternate build options, including run from RAM and program EEPROM.  These options will require the FXCore Dev Board or ISP programmer.

If you use the Run from Ram option, the FXCore will be held in this mode until you cancel it by pressing Ctrl-C or selecting Tools -> Cancel Build.
